"use strict";

var _GraphVertex = _interopRequireDefault(require("../../../../data-structures/graph/GraphVertex"));

var _GraphEdge = _interopRequireDefault(require("../../../../data-structures/graph/GraphEdge"));

var _Graph = _interopRequireDefault(require("../../../../data-structures/graph/Graph"));

var _detectDirectedCycle = _interopRequireDefault(require("../detectDirectedCycle"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('detectDirectedCycle', function () {
  it('should detect directed cycle', function () {
    var vertexA = new _GraphVertex.default('A');
    var vertexB = new _GraphVertex.default('B');
    var vertexC = new _GraphVertex.default('C');
    var vertexD = new _GraphVertex.default('D');
    var vertexE = new _GraphVertex.default('E');
    var vertexF = new _GraphVertex.default('F');
    var edgeAB = new _GraphEdge.default(vertexA, vertexB);
    var edgeBC = new _GraphEdge.default(vertexB, vertexC);
    var edgeAC = new _GraphEdge.default(vertexA, vertexC);
    var edgeDA = new _GraphEdge.default(vertexD, vertexA);
    var edgeDE = new _GraphEdge.default(vertexD, vertexE);
    var edgeEF = new _GraphEdge.default(vertexE, vertexF);
    var edgeFD = new _GraphEdge.default(vertexF, vertexD);
    var graph = new _Graph.default(true);
    graph.addEdge(edgeAB).addEdge(edgeBC).addEdge(edgeAC).addEdge(edgeDA).addEdge(edgeDE).addEdge(edgeEF);
    expect((0, _detectDirectedCycle.default)(graph)).toBeNull();
    graph.addEdge(edgeFD);
    expect((0, _detectDirectedCycle.default)(graph)).toEqual({
      D: vertexF,
      F: vertexE,
      E: vertexD
    });
  });
});