"use strict";

var _GraphVertex = _interopRequireDefault(require("../../../../data-structures/graph/GraphVertex"));

var _GraphEdge = _interopRequireDefault(require("../../../../data-structures/graph/GraphEdge"));

var _Graph = _interopRequireDefault(require("../../../../data-structures/graph/Graph"));

var _detectUndirectedCycleUsingDisjointSet = _interopRequireDefault(require("../detectUndirectedCycleUsingDisjointSet"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('detectUndirectedCycleUsingDisjointSet', function () {
  it('should detect undirected cycle', function () {
    var vertexA = new _GraphVertex.default('A');
    var vertexB = new _GraphVertex.default('B');
    var vertexC = new _GraphVertex.default('C');
    var vertexD = new _GraphVertex.default('D');
    var vertexE = new _GraphVertex.default('E');
    var vertexF = new _GraphVertex.default('F');
    var edgeAF = new _GraphEdge.default(vertexA, vertexF);
    var edgeAB = new _GraphEdge.default(vertexA, vertexB);
    var edgeBE = new _GraphEdge.default(vertexB, vertexE);
    var edgeBC = new _GraphEdge.default(vertexB, vertexC);
    var edgeCD = new _GraphEdge.default(vertexC, vertexD);
    var edgeDE = new _GraphEdge.default(vertexD, vertexE);
    var graph = new _Graph.default();
    graph.addEdge(edgeAF).addEdge(edgeAB).addEdge(edgeBE).addEdge(edgeBC).addEdge(edgeCD);
    expect((0, _detectUndirectedCycleUsingDisjointSet.default)(graph)).toBe(false);
    graph.addEdge(edgeDE);
    expect((0, _detectUndirectedCycleUsingDisjointSet.default)(graph)).toBe(true);
  });
});