"use strict";

var _GraphVertex = _interopRequireDefault(require("../../../../data-structures/graph/GraphVertex"));

var _GraphEdge = _interopRequireDefault(require("../../../../data-structures/graph/GraphEdge"));

var _Graph = _interopRequireDefault(require("../../../../data-structures/graph/Graph"));

var _topologicalSort = _interopRequireDefault(require("../topologicalSort"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('topologicalSort', function () {
  it('should do topological sorting on graph', function () {
    var vertexA = new _GraphVertex.default('A');
    var vertexB = new _GraphVertex.default('B');
    var vertexC = new _GraphVertex.default('C');
    var vertexD = new _GraphVertex.default('D');
    var vertexE = new _GraphVertex.default('E');
    var vertexF = new _GraphVertex.default('F');
    var vertexG = new _GraphVertex.default('G');
    var vertexH = new _GraphVertex.default('H');
    var edgeAC = new _GraphEdge.default(vertexA, vertexC);
    var edgeBC = new _GraphEdge.default(vertexB, vertexC);
    var edgeBD = new _GraphEdge.default(vertexB, vertexD);
    var edgeCE = new _GraphEdge.default(vertexC, vertexE);
    var edgeDF = new _GraphEdge.default(vertexD, vertexF);
    var edgeEF = new _GraphEdge.default(vertexE, vertexF);
    var edgeEH = new _GraphEdge.default(vertexE, vertexH);
    var edgeFG = new _GraphEdge.default(vertexF, vertexG);
    var graph = new _Graph.default(true);
    graph.addEdge(edgeAC).addEdge(edgeBC).addEdge(edgeBD).addEdge(edgeCE).addEdge(edgeDF).addEdge(edgeEF).addEdge(edgeEH).addEdge(edgeFG);
    var sortedVertices = (0, _topologicalSort.default)(graph);
    expect(sortedVertices).toBeDefined();
    expect(sortedVertices.length).toBe(graph.getAllVertices().length);
    expect(sortedVertices).toEqual([vertexB, vertexD, vertexA, vertexC, vertexE, vertexH, vertexF, vertexG]);
  });
});