"use strict";

var _GraphVertex = _interopRequireDefault(require("../../../../data-structures/graph/GraphVertex"));

var _GraphEdge = _interopRequireDefault(require("../../../../data-structures/graph/GraphEdge"));

var _Graph = _interopRequireDefault(require("../../../../data-structures/graph/Graph"));

var _bfTravellingSalesman = _interopRequireDefault(require("../bfTravellingSalesman"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('bfTravellingSalesman', function () {
  it('should solve problem for simple graph', function () {
    var vertexA = new _GraphVertex.default('A');
    var vertexB = new _GraphVertex.default('B');
    var vertexC = new _GraphVertex.default('C');
    var vertexD = new _GraphVertex.default('D');
    var edgeAB = new _GraphEdge.default(vertexA, vertexB, 1);
    var edgeBD = new _GraphEdge.default(vertexB, vertexD, 1);
    var edgeDC = new _GraphEdge.default(vertexD, vertexC, 1);
    var edgeCA = new _GraphEdge.default(vertexC, vertexA, 1);
    var edgeBA = new _GraphEdge.default(vertexB, vertexA, 5);
    var edgeDB = new _GraphEdge.default(vertexD, vertexB, 8);
    var edgeCD = new _GraphEdge.default(vertexC, vertexD, 7);
    var edgeAC = new _GraphEdge.default(vertexA, vertexC, 4);
    var edgeAD = new _GraphEdge.default(vertexA, vertexD, 2);
    var edgeDA = new _GraphEdge.default(vertexD, vertexA, 3);
    var edgeBC = new _GraphEdge.default(vertexB, vertexC, 3);
    var edgeCB = new _GraphEdge.default(vertexC, vertexB, 9);
    var graph = new _Graph.default(true);
    graph.addEdge(edgeAB).addEdge(edgeBD).addEdge(edgeDC).addEdge(edgeCA).addEdge(edgeBA).addEdge(edgeDB).addEdge(edgeCD).addEdge(edgeAC).addEdge(edgeAD).addEdge(edgeDA).addEdge(edgeBC).addEdge(edgeCB);
    var salesmanPath = (0, _bfTravellingSalesman.default)(graph);
    expect(salesmanPath.length).toBe(4);
    expect(salesmanPath[0].getKey()).toEqual(vertexA.getKey());
    expect(salesmanPath[1].getKey()).toEqual(vertexB.getKey());
    expect(salesmanPath[2].getKey()).toEqual(vertexD.getKey());
    expect(salesmanPath[3].getKey()).toEqual(vertexC.getKey());
  });
});