"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Comparator = _interopRequireDefault(require("../../utils/comparator/Comparator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * @typedef {Object} SorterCallbacks
 * @property {function(a: *, b: *)} compareCallback - If provided then all elements comparisons
 *  will be done through this callback.
 * @property {function(a: *)} visitingCallback - If provided it will be called each time the sorting
 *  function is visiting the next element.
 */
var Sort =
/*#__PURE__*/
function () {
  function Sort(originalCallbacks) {
    _classCallCheck(this, Sort);

    this.callbacks = Sort.initSortingCallbacks(originalCallbacks);
    this.comparator = new _Comparator.default(this.callbacks.compareCallback);
  }
  /**
   * @param {SorterCallbacks} originalCallbacks
   * @returns {SorterCallbacks}
   */


  _createClass(Sort, [{
    key: "sort",
    value: function sort() {
      throw new Error('sort method must be implemented');
    }
  }], [{
    key: "initSortingCallbacks",
    value: function initSortingCallbacks(originalCallbacks) {
      var callbacks = originalCallbacks || {};

      var stubCallback = function stubCallback() {};

      callbacks.compareCallback = callbacks.compareCallback || undefined;
      callbacks.visitingCallback = callbacks.visitingCallback || stubCallback;
      return callbacks;
    }
  }]);

  return Sort;
}();

exports.default = Sort;