"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SortTester = exports.negativeArrSorted = exports.negativeArr = exports.equalArr = exports.notSortedArr = exports.reverseArr = exports.sortedArr = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var sortedArr = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20];
exports.sortedArr = sortedArr;
var reverseArr = [20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1];
exports.reverseArr = reverseArr;
var notSortedArr = [15, 8, 5, 12, 10, 1, 16, 9, 11, 7, 20, 3, 2, 6, 17, 18, 4, 13, 14, 19];
exports.notSortedArr = notSortedArr;
var equalArr = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
exports.equalArr = equalArr;
var negativeArr = [-1, 0, 5, -10, 20, 13, -7, 3, 2, -3];
exports.negativeArr = negativeArr;
var negativeArrSorted = [-10, -7, -3, -1, 0, 2, 3, 5, 13, 20];
exports.negativeArrSorted = negativeArrSorted;

var SortTester =
/*#__PURE__*/
function () {
  function SortTester() {
    _classCallCheck(this, SortTester);
  }

  _createClass(SortTester, null, [{
    key: "testSort",
    value: function testSort(SortingClass) {
      var sorter = new SortingClass();
      expect(sorter.sort([])).toEqual([]);
      expect(sorter.sort([1])).toEqual([1]);
      expect(sorter.sort([1, 2])).toEqual([1, 2]);
      expect(sorter.sort([2, 1])).toEqual([1, 2]);
      expect(sorter.sort([3, 4, 2, 1, 0, 0, 4, 3, 4, 2])).toEqual([0, 0, 1, 2, 2, 3, 3, 4, 4, 4]);
      expect(sorter.sort(sortedArr)).toEqual(sortedArr);
      expect(sorter.sort(reverseArr)).toEqual(sortedArr);
      expect(sorter.sort(notSortedArr)).toEqual(sortedArr);
      expect(sorter.sort(equalArr)).toEqual(equalArr);
    }
  }, {
    key: "testNegativeNumbersSort",
    value: function testNegativeNumbersSort(SortingClass) {
      var sorter = new SortingClass();
      expect(sorter.sort(negativeArr)).toEqual(negativeArrSorted);
    }
  }, {
    key: "testSortWithCustomComparator",
    value: function testSortWithCustomComparator(SortingClass) {
      var callbacks = {
        compareCallback: function compareCallback(a, b) {
          if (a.length === b.length) {
            return 0;
          }

          return a.length < b.length ? -1 : 1;
        }
      };
      var sorter = new SortingClass(callbacks);
      expect(sorter.sort([''])).toEqual(['']);
      expect(sorter.sort(['a'])).toEqual(['a']);
      expect(sorter.sort(['aa', 'a'])).toEqual(['a', 'aa']);
      expect(sorter.sort(['aa', 'q', 'bbbb', 'ccc'])).toEqual(['q', 'aa', 'ccc', 'bbbb']);
      expect(sorter.sort(['aa', 'aa'])).toEqual(['aa', 'aa']);
    }
  }, {
    key: "testSortStability",
    value: function testSortStability(SortingClass) {
      var callbacks = {
        compareCallback: function compareCallback(a, b) {
          if (a.length === b.length) {
            return 0;
          }

          return a.length < b.length ? -1 : 1;
        }
      };
      var sorter = new SortingClass(callbacks);
      expect(sorter.sort(['bb', 'aa', 'c'])).toEqual(['c', 'bb', 'aa']);
      expect(sorter.sort(['aa', 'q', 'a', 'bbbb', 'ccc'])).toEqual(['q', 'a', 'aa', 'ccc', 'bbbb']);
    }
  }, {
    key: "testAlgorithmTimeComplexity",
    value: function testAlgorithmTimeComplexity(SortingClass, arrayToBeSorted, numberOfVisits) {
      var visitingCallback = jest.fn();
      var callbacks = {
        visitingCallback: visitingCallback
      };
      var sorter = new SortingClass(callbacks);
      sorter.sort(arrayToBeSorted);
      expect(visitingCallback).toHaveBeenCalledTimes(numberOfVisits);
    }
  }]);

  return SortTester;
}();

exports.SortTester = SortTester;