"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Sort2 = _interopRequireDefault(require("../Sort"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var CountingSort =
/*#__PURE__*/
function (_Sort) {
  _inherits(CountingSort, _Sort);

  function CountingSort() {
    _classCallCheck(this, CountingSort);

    return _possibleConstructorReturn(this, _getPrototypeOf(CountingSort).apply(this, arguments));
  }

  _createClass(CountingSort, [{
    key: "sort",

    /**
     * @param {number[]} originalArray
     * @param {number} [smallestElement]
     * @param {number} [biggestElement]
     */
    value: function sort(originalArray) {
      var _this = this;

      var smallestElement = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
      var biggestElement = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
      // Init biggest and smallest elements in array in order to build number bucket array later.
      var detectedSmallestElement = smallestElement || 0;
      var detectedBiggestElement = biggestElement || 0;

      if (smallestElement === undefined || biggestElement === undefined) {
        originalArray.forEach(function (element) {
          // Visit element.
          _this.callbacks.visitingCallback(element); // Detect biggest element.


          if (_this.comparator.greaterThan(element, detectedBiggestElement)) {
            detectedBiggestElement = element;
          } // Detect smallest element.


          if (_this.comparator.lessThan(element, detectedSmallestElement)) {
            detectedSmallestElement = element;
          }
        });
      } // Init buckets array.
      // This array will hold frequency of each number from originalArray.


      var buckets = Array(detectedBiggestElement - detectedSmallestElement + 1).fill(0);
      originalArray.forEach(function (element) {
        // Visit element.
        _this.callbacks.visitingCallback(element);

        buckets[element - detectedSmallestElement] += 1;
      }); // Add previous frequencies to the current one for each number in bucket
      // to detect how many numbers less then current one should be standing to
      // the left of current one.

      for (var bucketIndex = 1; bucketIndex < buckets.length; bucketIndex += 1) {
        buckets[bucketIndex] += buckets[bucketIndex - 1];
      } // Now let's shift frequencies to the right so that they show correct numbers.
      // I.e. if we won't shift right than the value of buckets[5] will display how many
      // elements less than 5 should be placed to the left of 5 in sorted array
      // INCLUDING 5th. After shifting though this number will not include 5th anymore.


      buckets.pop();
      buckets.unshift(0); // Now let's assemble sorted array.

      var sortedArray = Array(originalArray.length).fill(null);

      for (var elementIndex = 0; elementIndex < originalArray.length; elementIndex += 1) {
        // Get the element that we want to put into correct sorted position.
        var element = originalArray[elementIndex]; // Visit element.

        this.callbacks.visitingCallback(element); // Get correct position of this element in sorted array.

        var elementSortedPosition = buckets[element - detectedSmallestElement]; // Put element into correct position in sorted array.

        sortedArray[elementSortedPosition] = element; // Increase position of current element in the bucket for future correct placements.

        buckets[element - detectedSmallestElement] += 1;
      } // Return sorted array.


      return sortedArray;
    }
  }]);

  return CountingSort;
}(_Sort2.default);

exports.default = CountingSort;