"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Sort2 = _interopRequireDefault(require("../Sort"));

var _MinHeap = _interopRequireDefault(require("../../../data-structures/heap/MinHeap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var HeapSort =
/*#__PURE__*/
function (_Sort) {
  _inherits(HeapSort, _Sort);

  function HeapSort() {
    _classCallCheck(this, HeapSort);

    return _possibleConstructorReturn(this, _getPrototypeOf(HeapSort).apply(this, arguments));
  }

  _createClass(HeapSort, [{
    key: "sort",
    value: function sort(originalArray) {
      var _this = this;

      var sortedArray = [];
      var minHeap = new _MinHeap.default(this.callbacks.compareCallback); // Insert all array elements to the heap.

      originalArray.forEach(function (element) {
        // Call visiting callback.
        _this.callbacks.visitingCallback(element);

        minHeap.add(element);
      }); // Now we have min heap with minimal element always on top.
      // Let's poll that minimal element one by one and thus form the sorted array.

      while (!minHeap.isEmpty()) {
        var nextMinElement = minHeap.poll(); // Call visiting callback.

        this.callbacks.visitingCallback(nextMinElement);
        sortedArray.push(nextMinElement);
      }

      return sortedArray;
    }
  }]);

  return HeapSort;
}(_Sort2.default);

exports.default = HeapSort;