"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Sort2 = _interopRequireDefault(require("../Sort"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var QuickSort =
/*#__PURE__*/
function (_Sort) {
  _inherits(QuickSort, _Sort);

  function QuickSort() {
    _classCallCheck(this, QuickSort);

    return _possibleConstructorReturn(this, _getPrototypeOf(QuickSort).apply(this, arguments));
  }

  _createClass(QuickSort, [{
    key: "sort",

    /**
     * @param {*[]} originalArray
     * @return {*[]}
     */
    value: function sort(originalArray) {
      // Clone original array to prevent it from modification.
      var array = _toConsumableArray(originalArray); // If array has less than or equal to one elements then it is already sorted.


      if (array.length <= 1) {
        return array;
      } // Init left and right arrays.


      var leftArray = [];
      var rightArray = []; // Take the first element of array as a pivot.

      var pivotElement = array.shift();
      var centerArray = [pivotElement]; // Split all array elements between left, center and right arrays.

      while (array.length) {
        var currentElement = array.shift(); // Call visiting callback.

        this.callbacks.visitingCallback(currentElement);

        if (this.comparator.equal(currentElement, pivotElement)) {
          centerArray.push(currentElement);
        } else if (this.comparator.lessThan(currentElement, pivotElement)) {
          leftArray.push(currentElement);
        } else {
          rightArray.push(currentElement);
        }
      } // Sort left and right arrays.


      var leftArraySorted = this.sort(leftArray);
      var rightArraySorted = this.sort(rightArray); // Let's now join sorted left array with center array and with sorted right array.

      return leftArraySorted.concat(centerArray, rightArraySorted);
    }
  }]);

  return QuickSort;
}(_Sort2.default);

exports.default = QuickSort;