"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * Class that represents queen position on the chessboard.
 */
var QueenPosition =
/*#__PURE__*/
function () {
  /**
   * @param {number} rowIndex
   * @param {number} columnIndex
   */
  function QueenPosition(rowIndex, columnIndex) {
    _classCallCheck(this, QueenPosition);

    this.rowIndex = rowIndex;
    this.columnIndex = columnIndex;
  }
  /**
   * @return {number}
   */


  _createClass(QueenPosition, [{
    key: "toString",
    value: function toString() {
      return "".concat(this.rowIndex, ",").concat(this.columnIndex);
    }
  }, {
    key: "leftDiagonal",
    get: function get() {
      // Each position on the same left (\) diagonal has the same difference of
      // rowIndex and columnIndex. This fact may be used to quickly check if two
      // positions (queens) are on the same left diagonal.
      // @see https://youtu.be/xouin83ebxE?t=1m59s
      return this.rowIndex - this.columnIndex;
    }
    /**
     * @return {number}
     */

  }, {
    key: "rightDiagonal",
    get: function get() {
      // Each position on the same right diagonal (/) has the same
      // sum of rowIndex and columnIndex. This fact may be used to quickly
      // check if two positions (queens) are on the same right diagonal.
      // @see https://youtu.be/xouin83ebxE?t=1m59s
      return this.rowIndex + this.columnIndex;
    }
  }]);

  return QueenPosition;
}();

exports.default = QueenPosition;