"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _MinHeap2 = _interopRequireDefault(require("../heap/MinHeap"));

var _Comparator = _interopRequireDefault(require("../../utils/comparator/Comparator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

// It is the same as min heap except that when comparing to elements
// we take into account not element's value but rather its priority.
var PriorityQueue =
/*#__PURE__*/
function (_MinHeap) {
  _inherits(PriorityQueue, _MinHeap);

  function PriorityQueue() {
    var _this;

    _classCallCheck(this, PriorityQueue);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PriorityQueue).call(this));
    _this.priorities = {};
    _this.compare = new _Comparator.default(_this.comparePriority.bind(_assertThisInitialized(_this)));
    return _this;
  }
  /**
   * @param {*} item
   * @param {number} [priority]
   * @return {PriorityQueue}
   */


  _createClass(PriorityQueue, [{
    key: "add",
    value: function add(item) {
      var priority = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      this.priorities[item] = priority;

      _get(_getPrototypeOf(PriorityQueue.prototype), "add", this).call(this, item);

      return this;
    }
    /**
     * @param {*} item
     * @param {Comparator} [customFindingComparator]
     * @return {PriorityQueue}
     */

  }, {
    key: "remove",
    value: function remove(item, customFindingComparator) {
      _get(_getPrototypeOf(PriorityQueue.prototype), "remove", this).call(this, item, customFindingComparator);

      delete this.priorities[item];
      return this;
    }
    /**
     * @param {*} item
     * @param {number} priority
     * @return {PriorityQueue}
     */

  }, {
    key: "changePriority",
    value: function changePriority(item, priority) {
      this.remove(item, new _Comparator.default(this.compareValue));
      this.add(item, priority);
      return this;
    }
    /**
     * @param {*} item
     * @return {Number[]}
     */

  }, {
    key: "findByValue",
    value: function findByValue(item) {
      return this.find(item, new _Comparator.default(this.compareValue));
    }
    /**
     * @param {*} item
     * @return {boolean}
     */

  }, {
    key: "hasValue",
    value: function hasValue(item) {
      return this.findByValue(item).length > 0;
    }
    /**
     * @param {*} a
     * @param {*} b
     * @return {number}
     */

  }, {
    key: "comparePriority",
    value: function comparePriority(a, b) {
      if (this.priorities[a] === this.priorities[b]) {
        return 0;
      }

      return this.priorities[a] < this.priorities[b] ? -1 : 1;
    }
    /**
     * @param {*} a
     * @param {*} b
     * @return {number}
     */

  }, {
    key: "compareValue",
    value: function compareValue(a, b) {
      if (a === b) {
        return 0;
      }

      return a < b ? -1 : 1;
    }
  }]);

  return PriorityQueue;
}(_MinHeap2.default);

exports.default = PriorityQueue;