"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _BinarySearchTree2 = _interopRequireDefault(require("../binary-search-tree/BinarySearchTree"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var AvlTree =
/*#__PURE__*/
function (_BinarySearchTree) {
  _inherits(AvlTree, _BinarySearchTree);

  function AvlTree() {
    _classCallCheck(this, AvlTree);

    return _possibleConstructorReturn(this, _getPrototypeOf(AvlTree).apply(this, arguments));
  }

  _createClass(AvlTree, [{
    key: "insert",

    /**
     * @param {*} value
     */
    value: function insert(value) {
      // Do the normal BST insert.
      _get(_getPrototypeOf(AvlTree.prototype), "insert", this).call(this, value); // Let's move up to the root and check balance factors along the way.


      var currentNode = this.root.find(value);

      while (currentNode) {
        this.balance(currentNode);
        currentNode = currentNode.parent;
      }
    }
    /**
     * @param {*} value
     * @return {boolean}
     */

  }, {
    key: "remove",
    value: function remove(value) {
      // Do standard BST removal.
      _get(_getPrototypeOf(AvlTree.prototype), "remove", this).call(this, value); // Balance the tree starting from the root node.


      this.balance(this.root);
    }
    /**
     * @param {BinarySearchTreeNode} node
     */

  }, {
    key: "balance",
    value: function balance(node) {
      // If balance factor is not OK then try to balance the node.
      if (node.balanceFactor > 1) {
        // Left rotation.
        if (node.left.balanceFactor > 0) {
          // Left-Left rotation
          this.rotateLeftLeft(node);
        } else if (node.left.balanceFactor < 0) {
          // Left-Right rotation.
          this.rotateLeftRight(node);
        }
      } else if (node.balanceFactor < -1) {
        // Right rotation.
        if (node.right.balanceFactor < 0) {
          // Right-Right rotation
          this.rotateRightRight(node);
        } else if (node.right.balanceFactor > 0) {
          // Right-Left rotation.
          this.rotateRightLeft(node);
        }
      }
    }
    /**
     * @param {BinarySearchTreeNode} rootNode
     */

  }, {
    key: "rotateLeftLeft",
    value: function rotateLeftLeft(rootNode) {
      // Detach left node from root node.
      var leftNode = rootNode.left;
      rootNode.setLeft(null); // Make left node to be a child of rootNode's parent.

      if (rootNode.parent) {
        rootNode.parent.setLeft(leftNode);
      } else if (rootNode === this.root) {
        // If root node is root then make left node to be a new root.
        this.root = leftNode;
      } // If left node has a right child then detach it and
      // attach it as a left child for rootNode.


      if (leftNode.right) {
        rootNode.setLeft(leftNode.right);
      } // Attach rootNode to the right of leftNode.


      leftNode.setRight(rootNode);
    }
    /**
     * @param {BinarySearchTreeNode} rootNode
     */

  }, {
    key: "rotateLeftRight",
    value: function rotateLeftRight(rootNode) {
      // Detach left node from rootNode since it is going to be replaced.
      var leftNode = rootNode.left;
      rootNode.setLeft(null); // Detach right node from leftNode.

      var leftRightNode = leftNode.right;
      leftNode.setRight(null); // Preserve leftRightNode's left subtree.

      if (leftRightNode.left) {
        leftNode.setRight(leftRightNode.left);
        leftRightNode.setLeft(null);
      } // Attach leftRightNode to the rootNode.


      rootNode.setLeft(leftRightNode); // Attach leftNode as left node for leftRight node.

      leftRightNode.setLeft(leftNode); // Do left-left rotation.

      this.rotateLeftLeft(rootNode);
    }
    /**
     * @param {BinarySearchTreeNode} rootNode
     */

  }, {
    key: "rotateRightLeft",
    value: function rotateRightLeft(rootNode) {
      // Detach right node from rootNode since it is going to be replaced.
      var rightNode = rootNode.right;
      rootNode.setRight(null); // Detach left node from rightNode.

      var rightLeftNode = rightNode.left;
      rightNode.setLeft(null);

      if (rightLeftNode.right) {
        rightNode.setLeft(rightLeftNode.right);
        rightLeftNode.setRight(null);
      } // Attach rightLeftNode to the rootNode.


      rootNode.setRight(rightLeftNode); // Attach rightNode as right node for rightLeft node.

      rightLeftNode.setRight(rightNode); // Do right-right rotation.

      this.rotateRightRight(rootNode);
    }
    /**
     * @param {BinarySearchTreeNode} rootNode
     */

  }, {
    key: "rotateRightRight",
    value: function rotateRightRight(rootNode) {
      // Detach right node from root node.
      var rightNode = rootNode.right;
      rootNode.setRight(null); // Make right node to be a child of rootNode's parent.

      if (rootNode.parent) {
        rootNode.parent.setRight(rightNode);
      } else if (rootNode === this.root) {
        // If root node is root then make right node to be a new root.
        this.root = rightNode;
      } // If right node has a left child then detach it and
      // attach it as a right child for rootNode.


      if (rightNode.left) {
        rootNode.setRight(rightNode.left);
      } // Attach rootNode to the left of rightNode.


      rightNode.setLeft(rootNode);
    }
  }]);

  return AvlTree;
}(_BinarySearchTree2.default);

exports.default = AvlTree;