"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _BinarySearchTreeNode = _interopRequireDefault(require("./BinarySearchTreeNode"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var BinarySearchTree =
/*#__PURE__*/
function () {
  /**
   * @param {function} [nodeValueCompareFunction]
   */
  function BinarySearchTree(nodeValueCompareFunction) {
    _classCallCheck(this, BinarySearchTree);

    this.root = new _BinarySearchTreeNode.default(null, nodeValueCompareFunction); // Steal node comparator from the root.

    this.nodeComparator = this.root.nodeComparator;
  }
  /**
   * @param {*} value
   * @return {BinarySearchTreeNode}
   */


  _createClass(BinarySearchTree, [{
    key: "insert",
    value: function insert(value) {
      return this.root.insert(value);
    }
    /**
     * @param {*} value
     * @return {boolean}
     */

  }, {
    key: "contains",
    value: function contains(value) {
      return this.root.contains(value);
    }
    /**
     * @param {*} value
     * @return {boolean}
     */

  }, {
    key: "remove",
    value: function remove(value) {
      return this.root.remove(value);
    }
    /**
     * @return {string}
     */

  }, {
    key: "toString",
    value: function toString() {
      return this.root.toString();
    }
  }]);

  return BinarySearchTree;
}();

exports.default = BinarySearchTree;